Codeforces Round #518 (Div. 1) [Thanks, Mail.Ru!] B. Multihedgehog (多叉树)

Someone give a strange birthday present to Ivan. It is hedgehog — connected undirected graph in which one vertex has degree at least 3 (we will call it center) and all other vertices has degree 1. Ivan thought that hedgehog is too boring and decided to make himself k-multihedgehog.

Let us define k-multihedgehog as follows:

1-multihedgehog is hedgehog: it has one vertex of degree at least 3 and some vertices of degree 1.
For all k≥2, k-multihedgehog is (k−1)-multihedgehog in which the following changes has been made for each vertex v with degree 1: let u be its only neighbor; remove vertex v, create a new hedgehog with center at vertex w and connect vertices u and w with an edge. New hedgehogs can differ from each other and the initial gift.
Thereby k-multihedgehog is a tree. Ivan made k-multihedgehog but he is not sure that he did not make any mistakes. That is why he asked you to check if his tree is indeed k-multihedgehog.

Input
First line of input contains 2 integers n, k (1≤n≤105, 1≤k≤109) — number of vertices and hedgehog parameter.

Next n−1 lines contains two integers u v (1≤u,v≤n;u≠v) — indices of vertices connected by edge.

It is guaranteed that given graph is a tree.

Output
Print “Yes” (without quotes), if given graph is k-multihedgehog, and “No” (without quotes) otherwise.

Examples
inputCopy
14 2
1 4
2 4
3 4
4 13
10 5
11 5
12 5
14 5
5 13
6 7
8 6
13 6
9 6
outputCopy
Yes
inputCopy
3 1
1 3
2 3
outputCopy
No

题意:
1层数:第一层只有一个节点,而它有至少3个儿子节点。
2层树:第一层只有一个节点,而它有至少3个儿子节点;第二层所有的节点都至少有3个儿子节点。

k层树:第一层只有一个节点,而它有至少3个儿子节点;第二层所有的节点都至少有3个儿子节点…第k层所有的节点都至少有3个儿子节点。
现在有一颗树,判断是否是此类树。

思路: 由于是无相图,所有无法根据入度和出度判断根节点。可以先找到叶子节点,然后bfs向上搜,找到根节点。
再从根节点向下搜,每次记录当前节点儿子个数,并且记录树的深度。
若非叶子节点的儿子数目 >= 3,并且深度 == k,那么即是Yes。

#include<bits/stdc++.h>
using namespace std;
const int MAXN = 1000100;
typedef pair<int,int>P;
struct Edge
{
    int u,v,next;
}e[MAXN<<1];
int head[MAXN],cnt;
bool vis[MAXN];
int dep[MAXN];
int in[MAXN];

void addedge(int u,int v)
{
    e[cnt] = {u,v,head[u]};
    head[u] = cnt++;
}

int main()
{
    int n,k;
    scanf("%d%d",&n,&k);
    if(k >= 14){ cout<<"No"<<endl; return 0;}
    memset(head,-1,sizeof(head));
    for(int i = 1; i < n; ++i){
        int u,v;    scanf("%d%d",&u,&v);
        addedge(u,v);
        addedge(v,u);
        in[v]++;    in[u]++;
    }
    queue<int>q;
    for(int i = 1; i <= n; ++i)
        if(in[i] == 1)  q.push(i),vis[i] = true;
    int root;
    while(!q.empty()){
        int u = q.front();  q.pop();
        root = u;
        for(int i = head[u]; ~i; i = e[i].next){
            if(!vis[e[i].v])   q.push(e[i].v),vis[e[i].v] = true;
        }
    }
    queue<pair<int,int> >que;
    que.push(P(root,-1));
    dep[root] = 0;
    int flag = 0, mx;

    while(!que.empty()){
        int u = que.front().first,fa = que.front().second;  que.pop();
        mx = dep[u];
        int sum = 0;
        for(int i = head[u]; ~i; i = e[i].next){
            if(e[i].v != fa){
                que.push(P(e[i].v,u));
                dep[e[i].v] = dep[u] + 1;
                sum++;
            }
        }
        if(dep[u] + 1 <= k && sum < 3){ flag = 1; break; }

    }
    if(flag) { cout<<"No"<<endl;return 0; }
    if(mx == k) cout<<"Yes"<<endl;
    else cout<<"No"<<endl;
    return 0;
}

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
题目描述 给定一棵 $n$ 个节点的树,每个节点都有一个权值 $w_i$。你需要删去树上的一些边,使得剩下的每个连通块中,所有节点的权值之和不超过 $k$。 求最多能删去多少条边。 输入格式 第一行包含两个整数 $n,k$。 第二行包含 $n$ 个整数 $w_1,w_2,\cdots,w_n$。 接下来 $n-1$ 行,每行包含两个整数 $a,b$,表示节点 $a$ 和节点 $b$ 之间有一条边。 输出格式 输出一个整数,表示最多能删去的边数。 数据范围 $1\le n \le 10^5$ $1 \le k,w_i \le 10^9$ 输入样例1: 5 6 2 3 1 5 4 1 2 1 3 2 4 2 5 输出样例1: 2 输入样例2: 5 3 2 3 1 5 4 1 2 1 3 2 4 2 5 输出样例2: 0 算法1 (dfs) $O(n)$ 首先我们可以想到暴力的做法,即对于每个连通块,暴力枚举删去哪些边,尝试得到最多的删边数。那么如何求解一个连通块内的所有节点权值之和呢?我们可以使用 DFS 遍历树,对于每个节点,求出其子树内所有节点的权值之和,那么以该节点为根的子树内的所有节点权值之和就是该节点自身的权值加上其所有子节点的权值之和。 对于每个连通块,我们枚举该连通块内任意两个节点 $x,y$。如果 $x$ 与 $y$ 之间的路径上的所有边都被删去了,那么 $x$ 和 $y$ 就会分别成为两个新的连通块,这两个新的连通块内所有节点的权值之和都不超过 $k$。因此我们只需要枚举所有的 $x,y$ 对,对于每个 $x,y$ 对尝试删去它们之间的路径上的所有边,看是否能够让 $x$ 和 $y$ 成为两个新的连通块,进而更新答案即可。 时间复杂度 参考文献 python3 代码 算法2 (暴力枚举) $O(n^2)$ blablabla 时间复杂度 参考文献 C++ 代码 class Solution { public: const int N = 1e5+10; int n,k; int h[N],e[N<<1],ne[N<<1],idx; int w[N]; int sum[N]; bool st[N]; int res; void add(int a,int b) { e[idx] = b,ne[idx] = h[a],h[a] = idx++; } void dfs(int u,int father) { sum[u] = w[u]; for(int i=h[u];~i;i=ne[i]) { int j = e[i]; if(j == father) continue; dfs(j,u); sum[u] += sum[j]; } } void dfs2(int u,int father) { for(int i=h[u];~i;i=ne[i]) { int j = e[i]; if(j == father) continue; dfs2(j,u); if(sum[j] <= k) res++; else if(sum[u] - sum[j] <= k) res++; } } void solve() { cin >> n >> k; memset(h,-1,sizeof(h)); for(int i=1;i<=n;i++) cin >> w[i]; for(int i=1;i<n;i++) { int a,b; cin >> a >> b; add(a,b); add(b,a); } dfs(1,-1); dfs2(1,-1); cout << res << endl; } }; int main() { Solution().solve(); return 0; }

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值